-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

newTalent{
	name = "Evasion",
	type = {"cunning/survival", 4},
	points = 5,
	require = cuns_req4,
	random_ego = "defensive",
	tactical = { ESCAPE = 2, DEFEND = 2 },
	cooldown = 30,
	
	getDur = function(self) return 5+math.floor(25*self:getWil(10,true)/(self:getWil(10,true)+15)) end, --I5 Limit < 30
	getChanceDef = function(self, t) --I5
		local tl = self:getTalentLevel(t)*5 + self:getCun(25,true) + self:getDex(25,true) --I5
		return 50*tl/(tl+25), self:getTalentLevel(t)^.5 * (self:getCun(25,true) + self:getDex(25,true))/2 -- I5 Limit evasion chance <50%
	end,
	
	action = function(self, t)
		if config.settings.tome.game_mechanics.limited_evasion then
			local dur = t.getDur(self) --I5
			local chance,def = t.getChanceDef(self,t) --I5 Updated effect "EVASION" in data.temporary_effects.physical.lua
			self:setEffect(self.EFF_EVASION, dur, {chance=chance, defense = def}) --I5
			return true
		else
			local dur = 5 + self:getWil(10)
			local chance = 5 * self:getTalentLevel(t) + self:getCun(25, true) + self:getDex(25, true)
			self:setEffect(self.EFF_EVASION, dur, {chance=chance})
			return true
		end
	end,
	info = function(self, t)
		if config.settings.tome.game_mechanics.limited_evasion then
			local chance,def = t.getChanceDef(self,t)

			return ([[Your quick wit allows you to see attacks before they land, granting you a %d%% chance to completely evade them and granting you %d defense for %d turns.
			Duration increases with Willpower, and chance to evade and defense with Cunning and Dexterity.]]):
			format(chance, def,t.getDur(self))
		else
			return ([[Your quick wit allows you to see attacks before they land, granting you a %d%% chance to completely evade them for %d turns.
			Duration increases with your Willpower, and the chance to evade improves with your Cunning and Dexterity.]]):format(5 * self:getTalentLevel(t) + self:getCun(25, true) + self:getDex(25, true), t.getDur(self))
		end
	end,
}
