-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

-- Generic requires for racial based on talent level
racial_req1 = {
	level = function(level) return 0 + (level-1)  end,
}
racial_req2 = {
	level = function(level) return 8 + (level-1)  end,
}
racial_req3 = {
	level = function(level) return 16 + (level-1)  end,
}
racial_req4 = {
	level = function(level) return 24 + (level-1)  end,
}

newTalent{
	name = "Duck and Dodge",
	type = {"race/halfling", 2},
	
--I5	getEvasionChance = function(self, t) return self:getStat("lck") end,
	getEvasionChance = function(self, t)
		if config.settings.tome.game_mechanics.limited_evasion then
			return 50 
		else
			return self:getStat("lck")
		end
	end,
	
--I5	getDuration = function(self, t) return 1 + math.ceil(self:getTalentLevel(t)/2) end,
--	getDuration = function(self, t) return math.floor(0.45+1.6*self:getTalentLevel(t)^.5) end, --I5
--I5 _M:onTakeHit function in mod.class.Actor.lua updated for trigger 
--I5  "EVASION" effect updated in mod.data.timed_effects.physical.lua to implement effect
	getDefense = function(self)  --I5 
		if not config.settings.tome.game_mechanics.limited_evasion then
			return 0
		else
			local oldevasion = self:hasEffect(self.EFF_EVASION)
			return self:getStat("lck")/200*(self:combatDefenseBase() - (oldevasion and oldevasion.defense or 0)) --I5 Prevent stacking
		end
	end, --I5

	info = function(self, t)
		local threshold = t.getThreshold(self, t)
		local evasion = t.getEvasionChance(self, t)
		local duration = t.getDuration(self, t)
		if config.settings.tome.game_mechanics.limited_evasion then
			return ([[Your incredible luck kicks in at just the right moment to save your skin.
			Whenever you take %d%% or more of your life from a single attack, you gain Evasion (%d%%) and %d additional defense (based on your luck and other defensive stats) for the next %d turns.]]):
			format(threshold * 100, evasion, t.getDefense(self), duration)
		else
			return ([[Your incredible luck kicks in at just the right moment to save your skin.
			Whenever you take %d%% or more of your life from a single attack you gain Evasion equal to your luck stat (currently %d%%) for the next %d turns.]]):
			format(threshold * 100, evasion, duration)
		end
		
	end,
}

