-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

local tacticals = {}
local Entity = require "engine.Entity"
local Stats = require "engine.interface.ActorStats"
local Particles = require "engine.Particles"
local Chat = require "engine.Chat"
local Map = require "engine.Map"
local Level = require "engine.Level"
local TemporaryEffects = require "engine.interface.ActorTemporaryEffects"

local oldNewTalent = Talents.newTalent
Talents.newTalent = function(self, t)
	assert(engine.interface.ActorTalents.talents_types_def[t.type[1]], "No talent category "..tostring(t.type[1]).." for talent "..t.name)
	if engine.interface.ActorTalents.talents_types_def[t.type[1]].generic then t.generic = true end
	if engine.interface.ActorTalents.talents_types_def[t.type[1]].no_silence then t.no_silence = true end
	if engine.interface.ActorTalents.talents_types_def[t.type[1]].is_spell then t.is_spell = true end
	if engine.interface.ActorTalents.talents_types_def[t.type[1]].is_mind then t.is_mind = true end
	if engine.interface.ActorTalents.talents_types_def[t.type[1]].is_nature then t.is_nature = true end
	if engine.interface.ActorTalents.talents_types_def[t.type[1]].is_unarmed then t.is_unarmed = true end

	if t.tactical then
		local tacts = {}
		for tact, val in pairs(t.tactical) do
			tact = tact:lower()
			tacts[tact] = val
			tacticals[tact] = true
		end
		t.tactical = tacts
	end

	if not t.image then
		t.image = "talents/"..(t.short_name or t.name):lower():gsub("[^a-z0-9_]", "_")..".png"
	end
	if fs.exists("/data/gfx/"..t.image) then t.display_entity = Entity.new{image=t.image, is_talent=true}
	else t.display_entity = Entity.new{image="talents/default.png", is_talent=true}
	end
	return oldNewTalent(self, t)
end

damDesc = function(self, type, dam)
	-- Increases damage
	if self.inc_damage then
		local inc = (self.inc_damage.all or 0) + (self.inc_damage[type] or 0)
		dam = dam + (dam * inc / 100)
	end
	return dam
end

Talents.damDesc = damDesc
Talents.main_env = getfenv(1)

load("/data-GameMech/talents/cunning/survival.lua")
load("/data-GameMech/talents/misc/races.lua")


local oldNewEffect = TemporaryEffects.newEffect
TemporaryEffects.newEffect = function(self, t)
	if not t.image then
		t.image = "effects/"..(t.name):lower():gsub("[^a-z0-9_]", "_")..".png"
	end
	if fs.exists("/data/gfx/"..t.image) then t.display_entity = Entity.new{image=t.image, is_effect=true}
	else t.display_entity = Entity.new{image="effects/default.png", is_effect=true} print("===", t.type, t.name)
	end

	return oldNewEffect(self, t)
end

load("/data-GameMech/timed_effects/physicalGameMech.lua") --load evasion effect

--print("[TALENTS TACTICS]")
--for k, _ in pairs(tacticals) do print(" * ", k) end
